<?php
namespace Mageplaza\Blog\Block\Post\RelatedProduct;

/**
 * Interceptor class for @see \Mageplaza\Blog\Block\Post\RelatedProduct
 */
class Interceptor extends \Mageplaza\Blog\Block\Post\RelatedProduct implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Catalog\Block\Product\Context $context, \Magento\Framework\Data\Helper\PostHelper $postDataHelper, \Magento\Catalog\Model\Layer\Resolver $layerResolver, \Magento\Catalog\Api\CategoryRepositoryInterface $categoryRepository, \Magento\Catalog\Model\ResourceModel\Product\CollectionFactory $productCollectionFactory, \Magento\ConfigurableProduct\Model\ResourceModel\Product\Type\Configurable $catalogProductTypeConfigurable, \Magento\Catalog\Model\ProductRepository $productRepository, \Mageplaza\Blog\Helper\Data $helperData, \Magento\Catalog\Helper\Output $output, \Magento\Framework\Url\Helper\Data $urlHelper, array $data = [])
    {
        $this->___init();
        parent::__construct($context, $postDataHelper, $layerResolver, $categoryRepository, $productCollectionFactory, $catalogProductTypeConfigurable, $productRepository, $helperData, $output, $urlHelper, $data);
    }

    /**
     * {@inheritdoc}
     */
    public function getLoadedProductCollection()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getLoadedProductCollection');
        return $pluginInfo ? $this->___callPlugins('getLoadedProductCollection', func_get_args(), $pluginInfo) : parent::getLoadedProductCollection();
    }

    /**
     * {@inheritdoc}
     */
    public function getAddToCartPostParams(\Magento\Catalog\Model\Product $product)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getAddToCartPostParams');
        return $pluginInfo ? $this->___callPlugins('getAddToCartPostParams', func_get_args(), $pluginInfo) : parent::getAddToCartPostParams($product);
    }

    /**
     * {@inheritdoc}
     */
    public function getProductPrice(\Magento\Catalog\Model\Product $product)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getProductPrice');
        return $pluginInfo ? $this->___callPlugins('getProductPrice', func_get_args(), $pluginInfo) : parent::getProductPrice($product);
    }

    /**
     * {@inheritdoc}
     */
    public function getProductDetailsHtml(\Magento\Catalog\Model\Product $product)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getProductDetailsHtml');
        return $pluginInfo ? $this->___callPlugins('getProductDetailsHtml', func_get_args(), $pluginInfo) : parent::getProductDetailsHtml($product);
    }

    /**
     * {@inheritdoc}
     */
    public function getImage($product, $imageId, $attributes = [])
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getImage');
        return $pluginInfo ? $this->___callPlugins('getImage', func_get_args(), $pluginInfo) : parent::getImage($product, $imageId, $attributes);
    }

    /**
     * {@inheritdoc}
     */
    public function toHtml()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'toHtml');
        return $pluginInfo ? $this->___callPlugins('toHtml', func_get_args(), $pluginInfo) : parent::toHtml();
    }

    /**
     * {@inheritdoc}
     */
    public function getUrl($route = '', $params = [])
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getUrl');
        return $pluginInfo ? $this->___callPlugins('getUrl', func_get_args(), $pluginInfo) : parent::getUrl($route, $params);
    }

    /**
     * {@inheritdoc}
     */
    public function getData($key = '', $index = null)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getData');
        return $pluginInfo ? $this->___callPlugins('getData', func_get_args(), $pluginInfo) : parent::getData($key, $index);
    }
}
